signature Fiacre_TOKENS =
sig
type ('a,'b) token
type svalue
val NEXT:  'a * 'a -> (svalue,'a) token
val RELEASE:  'a * 'a -> (svalue,'a) token
val IMP:  'a * 'a -> (svalue,'a) token
val LTL:  'a * 'a -> (svalue,'a) token
val FOR:  'a * 'a -> (svalue,'a) token
val UNTIL:  'a * 'a -> (svalue,'a) token
val BETWEEN:  'a * 'a -> (svalue,'a) token
val BEFORE:  'a * 'a -> (svalue,'a) token
val AFTER:  'a * 'a -> (svalue,'a) token
val LASTING:  'a * 'a -> (svalue,'a) token
val WITHIN:  'a * 'a -> (svalue,'a) token
val PRECEDES:  'a * 'a -> (svalue,'a) token
val ALWAYS:  'a * 'a -> (svalue,'a) token
val LEADSTO:  'a * 'a -> (svalue,'a) token
val ABSENT:  'a * 'a -> (svalue,'a) token
val PRESENT:  'a * 'a -> (svalue,'a) token
val LIVE:  'a * 'a -> (svalue,'a) token
val MORTAL:  'a * 'a -> (svalue,'a) token
val INFINITELYOFTEN:  'a * 'a -> (svalue,'a) token
val DEADLOCKFREE:  'a * 'a -> (svalue,'a) token
val ASSERT:  'a * 'a -> (svalue,'a) token
val PROPERTY:  'a * 'a -> (svalue,'a) token
val RETURN: (int) *  'a * 'a -> (svalue,'a) token
val ON: (int) *  'a * 'a -> (svalue,'a) token
val WAIT: (int) *  'a * 'a -> (svalue,'a) token
val LOOP: (int) *  'a * 'a -> (svalue,'a) token
val RQBRACE:  'a * 'a -> (svalue,'a) token
val LQBRACE:  'a * 'a -> (svalue,'a) token
val FOREACH: (int) *  'a * 'a -> (svalue,'a) token
val CASE: (int) *  'a * 'a -> (svalue,'a) token
val CONST:  'a * 'a -> (svalue,'a) token
val INIT: (int) *  'a * 'a -> (svalue,'a) token
val DBAR:  'a * 'a -> (svalue,'a) token
val PAR: (int) *  'a * 'a -> (svalue,'a) token
val ARROW: (int) *  'a * 'a -> (svalue,'a) token
val IDENT: (string*int) *  'a * 'a -> (svalue,'a) token
val DEC: (real) *  'a * 'a -> (svalue,'a) token
val NAT: (int) *  'a * 'a -> (svalue,'a) token
val COMPONENT:  'a * 'a -> (svalue,'a) token
val EOF:  'a * 'a -> (svalue,'a) token
val RBRACE:  'a * 'a -> (svalue,'a) token
val LBRACE:  'a * 'a -> (svalue,'a) token
val RPAREN:  'a * 'a -> (svalue,'a) token
val LPAREN:  'a * 'a -> (svalue,'a) token
val RBRACK:  'a * 'a -> (svalue,'a) token
val LBRACK:  'a * 'a -> (svalue,'a) token
val INF:  'a * 'a -> (svalue,'a) token
val ALT:  'a * 'a -> (svalue,'a) token
val SEMICOLON: (int) *  'a * 'a -> (svalue,'a) token
val COMMA:  'a * 'a -> (svalue,'a) token
val COLON:  'a * 'a -> (svalue,'a) token
val ASSIGN: (int) *  'a * 'a -> (svalue,'a) token
val DOT:  'a * 'a -> (svalue,'a) token
val TWODOT:  'a * 'a -> (svalue,'a) token
val SEND:  'a * 'a -> (svalue,'a) token
val NE:  'a * 'a -> (svalue,'a) token
val EQ:  'a * 'a -> (svalue,'a) token
val GT:  'a * 'a -> (svalue,'a) token
val GE:  'a * 'a -> (svalue,'a) token
val LE:  'a * 'a -> (svalue,'a) token
val LT:  'a * 'a -> (svalue,'a) token
val COERCE:  'a * 'a -> (svalue,'a) token
val DIV:  'a * 'a -> (svalue,'a) token
val SHARP: (int*int) *  'a * 'a -> (svalue,'a) token
val MUL:  'a * 'a -> (svalue,'a) token
val SUB:  'a * 'a -> (svalue,'a) token
val MOD:  'a * 'a -> (svalue,'a) token
val ADD:  'a * 'a -> (svalue,'a) token
val MID:  'a * 'a -> (svalue,'a) token
val IS: (int*int) *  'a * 'a -> (svalue,'a) token
val BEGIN:  'a * 'a -> (svalue,'a) token
val AMP:  'a * 'a -> (svalue,'a) token
val TYPE:  'a * 'a -> (svalue,'a) token
val CHANNEL:  'a * 'a -> (svalue,'a) token
val OR:  'a * 'a -> (svalue,'a) token
val AND:  'a * 'a -> (svalue,'a) token
val RCVE:  'a * 'a -> (svalue,'a) token
val DO:  'a * 'a -> (svalue,'a) token
val WHILE: (int) *  'a * 'a -> (svalue,'a) token
val NULL:  'a * 'a -> (svalue,'a) token
val WRITE:  'a * 'a -> (svalue,'a) token
val READ:  'a * 'a -> (svalue,'a) token
val PORT:  'a * 'a -> (svalue,'a) token
val PRIORITY:  'a * 'a -> (svalue,'a) token
val STATES: (int) *  'a * 'a -> (svalue,'a) token
val SYNC:  'a * 'a -> (svalue,'a) token
val OUT:  'a * 'a -> (svalue,'a) token
val IN:  'a * 'a -> (svalue,'a) token
val APPEND:  'a * 'a -> (svalue,'a) token
val ENQUEUE:  'a * 'a -> (svalue,'a) token
val DEQUEUE:  'a * 'a -> (svalue,'a) token
val EMPTY:  'a * 'a -> (svalue,'a) token
val LENGTH:  'a * 'a -> (svalue,'a) token
val FIRST:  'a * 'a -> (svalue,'a) token
val FULL:  'a * 'a -> (svalue,'a) token
val FALSE:  'a * 'a -> (svalue,'a) token
val TRUE:  'a * 'a -> (svalue,'a) token
val T_INT:  'a * 'a -> (svalue,'a) token
val T_NAT:  'a * 'a -> (svalue,'a) token
val T_BOOL:  'a * 'a -> (svalue,'a) token
val ARRAY:  'a * 'a -> (svalue,'a) token
val TO: (int) *  'a * 'a -> (svalue,'a) token
val END:  'a * 'a -> (svalue,'a) token
val SELECT:  'a * 'a -> (svalue,'a) token
val ELSIF: (int) *  'a * 'a -> (svalue,'a) token
val ELSE:  'a * 'a -> (svalue,'a) token
val THEN:  'a * 'a -> (svalue,'a) token
val OF:  'a * 'a -> (svalue,'a) token
val IF: (int) *  'a * 'a -> (svalue,'a) token
val WHERE:  'a * 'a -> (svalue,'a) token
val ANY:  'a * 'a -> (svalue,'a) token
val FROM: (int) *  'a * 'a -> (svalue,'a) token
val VAR:  'a * 'a -> (svalue,'a) token
val EXTERN:  'a * 'a -> (svalue,'a) token
val FUNCTION:  'a * 'a -> (svalue,'a) token
val NOT:  'a * 'a -> (svalue,'a) token
val INFTY:  'a * 'a -> (svalue,'a) token
val PROCESS:  'a * 'a -> (svalue,'a) token
val QUEUE:  'a * 'a -> (svalue,'a) token
val RECORD:  'a * 'a -> (svalue,'a) token
val UNION:  'a * 'a -> (svalue,'a) token
end
signature Fiacre_LRVALS=
sig
structure Tokens : Fiacre_TOKENS
structure ParserData:PARSER_DATA
sharing type ParserData.Token.token = Tokens.token
sharing type ParserData.svalue = Tokens.svalue
end
